#include "../freebl/fips-selftest.inc"

#include "fips.h"

#include "softoken.h"

#include <dlfcn.h>

/* crypto algorithms selftest wrapper */
static fips_check_status
fips_checkCryptoSoftoken(void)
{
    if (CKR_OK == sftk_FIPSEntryOK()) {
	return CHECK_OK;
    } else {
	return CHECK_FAIL_CRYPTO;
    }

    return CHECK_OK;
}

/* constructor - load-time selfchecks */
static void __attribute__ ((constructor))
fips_initTestSoftoken(void)
{
    fips_state = fips_initTest("softokn", (PRFuncPtr)fips_initTestSoftoken, fips_checkCryptoSoftoken);

    /* The legacy DB must be checked unconditionally. The check is performed by
     * its constructor. */
    dlopen (SHLIB_PREFIX "nssdbm" SHLIB_VERSION "." SHLIB_SUFFIX, RTLD_LAZY);

    return;
}
